﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	import flash.ui.Mouse;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.filters.BlurFilter;
	import flash.filters.BitmapFilter;
    import flash.filters.BitmapFilterQuality;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.materials.special.CompositeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.BitmapFileMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.lights.PointLight3D;




	public class Damier extends Sprite
	{
	
		private var col:Number = 101;
		private var line:Number = 101;
		private var grid:Sprite;
		private var points:Array;
		
		private var shift:Number = 6;
		
		private var b:BitmapData;
		private var toCopy:BitmapData;
		private var loader:Loader;
		private var img:Bitmap;
		
		private var brightness:Number;
		private var pixel:uint;

		private var rect:Rectangle = new Rectangle(0,0, stage.stageWidth,stage.stageHeight);
		
		private var maxHeight:int = 10;
		
		private var matList:MaterialsList;
			
		private var imgMat_1:BitmapFileMaterial = new BitmapFileMaterial("data/alphab1.jpg");
		private var imgMat_2:BitmapFileMaterial = new BitmapFileMaterial("data/alphab2.jpg");
		private var imgMat_3:BitmapFileMaterial = new BitmapFileMaterial("data/alphab3.jpg");
		private var imgMat_4:BitmapFileMaterial = new BitmapFileMaterial("data/alphab4.jpg");
		private var imgMat_5:BitmapFileMaterial = new BitmapFileMaterial("data/alphab5.jpg");
		private var imgMat_6:BitmapFileMaterial = new BitmapFileMaterial("data/alphab6.jpg");
		
		
		// papervision
		private var viewport:Viewport3D;
		private var scene3d:Scene3D;
		private var camera:Camera3D;		
		private var renderer:BasicRenderEngine;
		private var matCom:CompositeMaterial;
		private var cub:Cube;
		
		public function Damier()
		{
			grid = new Sprite();
			addChild(grid);
			
			toCopy = new BitmapData(stage.stageWidth,stage.stageHeight,false)
			
			initMaterials();
			init();
		}
		
		private function initMaterials():void
		{
			matList = new MaterialsList();
			
			matList.addMaterial( imgMat_1, "front");
			matList.addMaterial( imgMat_2, "left");
			matList.addMaterial( imgMat_3, "right");
			matList.addMaterial( imgMat_4, "top");
			matList.addMaterial( imgMat_5, "back");
			matList.addMaterial( imgMat_6, "bottom");
			
		}
		
		private function init()
		{
			scene3d = new Scene3D();
			camera = new Camera3D();
			camera.zoom = 100;
			
			renderer = new BasicRenderEngine();
			viewport = new Viewport3D(stage.stageWidth, stage.stageHeight);
			//addChild(viewport);

			cub = new Cube(matList,350,350,350);
			scene3d.addChild(cub);
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		
		private function enterHandler(e:Event):void
		{
			toCopy.fillRect(rect, 0x000000);
			toCopy.draw(viewport);

			points = new Array();
			grid.graphics.clear();
			grid.graphics.lineStyle(1,0xffffff);
			
			
			for(var i:int = 0; i < col-1; i++){
				for(var j:int = 0; j < line; j++){
					
					//	calcul de la hauteur de chaque points qui constituent 
					//	les ligne en fonction du pixel se trouvant au-dessous
					pixel = toCopy.getPixel(j*shift, i*shift);
					brightness = pixel / 0xFFFFFF;
					points.push({"x":j*shift,"y":i*shift+(Math.random()*.5)+(brightness*maxHeight)});//maxHeight
					
					//	j'enlève le "cafouillage" à la fin de chaque ligne, 
					//	il y a surement mieux à faire!
					if(j == line-1) points[points.length-1].x = j*shift + 1000;
				}
			}
			
			for(var k:Number=0;k<points.length;k++){
				
				if((k+1)%col != 0){
					grid.graphics.moveTo(points[k].x,points[k].y);
					grid.graphics.lineTo(points[k+1].x,points[k+1].y);
				}
			}
			
			cub.rotationY -= (mouseX-stage.stageWidth/2)/100;
			cub.rotationX -= (mouseY-stage.stageWidth/2)/100;
			renderer.renderScene(scene3d, camera, viewport);
		}
	}
}